
// dopis podminku pro new save load exit
#include <conio.h>
#include <string.h>
#include <math.h>
#include <dos.h>
#include "rat.h"

#define MEZI(x1,y1,x2,y2) if((((x1-1)*8<=x) && ((x2-1)*8>=x))&&(((y1-1)*8<=y) && ((y2-1)*8>=y)))
#define BOD(x1,y1) if (((x1-1)*8==x)&&((y1-1)*8==y))
//#define PRIPONA ".pmf"


#define MAX_MAPF_SIZE 255

#define MAX_MAP_XSIZE 200
#define MAX_MAP_YSIZE 200

#define VIDMEM 0xB800

void ramce2 (char x1,char y1,char x2,char y2);
void ramce1 (char x1,char y1,char x2,char y2);
void horiz1 (char x1,char x2,char y);
void vert1 (char y1,char y2,char x);
void pis (char *p,char x,char y);
void tabulka();
void text();
void init_znaky();
void vypis_vse();
void vypis_znaky();
void zapis_znak(int x,int y, char znak);
void vypis_mapu();
void uiscan (unsigned int *x,int x_scr, int y_scr);
void save_map(char map_file[]);
void load_map(char map_file[]);
void import_raw(int x1, int y1, char fname[]);
void init_mapf();
void init_map();
void nazev();
void bresenham (int x1,int y1,int x2,int y2,char znak);
void kruznice3 (int xs,int ys,int r,char znak);
void elipsa1 (int xs,int ys,int as,int bs, char znak);
void vypln (int x,int y,char znak);
void box (int x1,int y1,int x2,int y2,char znak);
void symetrie1 (int x,int y,int xs,int ys,char znak);
void symetrie2 (int x,int y,int xs,int ys,char znak);
int click(int x,int y);

// Map fields
int n_mapf_size=MAX_MAPF_SIZE;
struct s_mapf {
				unsigned char m; // Map field properties
				unsigned char c; // Char
				unsigned char f,b; // Foreground, background color
			  } mapf[MAX_MAPF_SIZE];

// Game map
unsigned int n_map_xsize=MAX_MAP_XSIZE;
unsigned int n_map_ysize=MAX_MAP_YSIZE;

struct s_map {
			   char *name; // Map name
			   unsigned char m[MAX_MAP_XSIZE][MAX_MAP_YSIZE]; // Map fields properties
			 } map;

char znak=32;

s_mapf str_i[28];

unsigned int mode=0;     //  0  normal mode
			 //  1  prosp  mode
			 //  2  first player setting mode
			 //  3  second player setting mode
			 //  4  third setting mode
			 //  5  fourth player setting mode
			 //  6  view start positions

unsigned int tool=0;     //  0  brush
			 //  1  line
			 //  2  circle
			 //  3  elipse
			 //  4  vypln
	  //  5  box

unsigned char prev=0;    //  0 maluje
			 //  1 preview
			 //  2 rusi preview

unsigned char full=0; // 0 normal mode
                      // 1 full screen
unsigned int start_x[4]={1,2,3,4};
unsigned int start_y[4]={1,1,1,1};
unsigned int x_view=0;
unsigned int y_view=0;
unsigned char far *screen;

int main(void)
{
int x,y;
int x_old,y_old;
int xk,yk;
char zmena=0;
int klik=0;
char mys,c;
char *name;

map.name="-=          Test map          =-";
//struct palettetype pal;
screen=(unsigned char*) MK_FP(VIDMEM,0);
init_znaky();
init_map();
init_mapf();
textmode(C4350);  //80*50
_setcursortype(_NOCURSOR);
en();
clrscr();
locate (1,1);
tabulka();
text();

do{
textcolor(15);
textbackground(0);
do{
if (zmena==0&&prev==1)
   {
   switch (tool)
	 {
	 case 1:
	 bresenham(xk/8-3,yk/8-10,x/8-3,y/8-10,znak-32);
	 break;
	 case 2:
	 kruznice3(xk/8-3,yk/8-10,sqrt(abs(((x-xk)/8)*((x-xk)/8)+((y-yk)/8)*((y-yk)/8))),znak-32);
	 break;
	 case 3:
	 elipsa1(xk/8-3,yk/8-10,abs((x-xk)/8),abs((y-yk)/8),znak-32);
	 break;
	 case 5:
	 box(xk/8-3,yk/8-10,x/8-3,y/8-10,znak-32);
	 break;
	 }
   prev=2;
   }
x_old=x;
y_old=y;
mys=status(3,&x,&y);
if (x==x_old&&y==y_old) zmena=1;
   else zmena=0;
if (prev==2&&zmena==0)
   {
   switch (tool)
	 {
	 case 1:
	 bresenham(xk/8-3,yk/8-10,x_old/8-3,y_old/8-10,znak-32);
	 break;
	 case 2:
	 kruznice3(xk/8-3,yk/8-10,sqrt(abs(((x_old-xk)/8)*((x_old-xk)/8)+((y_old-yk)/8)*((y_old-yk)/8))),znak-32);
	 break;
	 case 3:
	 elipsa1(xk/8-3,yk/8-10,abs((x_old-xk)/8),abs((y_old-yk)/8),znak-32);
	 break;
	 case 5:
	 box(xk/8-3,yk/8-10,x_old/8-3,y_old/8-10,znak-32);
	 break;
	 }
   prev=1;
   }
gotoxy (5,7);
cprintf ("[%d;%d]      ",x/8-2+x_view,y/8-9+y_view);
}while(mys==0&&!kbhit());

if (kbhit())
	{
	c=getch();
	if (c=='m'||c=='M') {mode=(mode==0)?1:0;vypis_mapu();vypis_znaky();}
	if (c=='n'||c=='N') {init_map();vypis_mapu();}
	if (c=='l'||c=='L') {gotoxy(4,8);scanf("%s",name);load_map(name);vypis_mapu();}
	if (c=='s'||c=='S') {gotoxy(4,8);scanf("%s",name);save_map(name);vypis_mapu();}
	if (c=='i'||c=='I') {gotoxy(4,8);scanf("%s",name);import_raw(100,100,name);vypis_mapu();}
	if (c=='z'||c=='Z') {mode=(mode==6)?0:6;vypis_mapu();}
	if (c=='h'||c=='H') {}
   if (c=='f'||c=='F') {full=(full==0)?1:0;vypis_vse();}

	if (c==0 && kbhit())
	   {
	   c=getch();
		if (c=='K'&&(x_view>0)) {x_view--;vypis_mapu();delay(1);}
      if (c=='K') c=0;
		if (c=='M'&&(x_view<(n_map_xsize-35))) {x_view++;vypis_mapu();delay(1);}
		if (c=='H'&&(y_view>0)) {y_view--;vypis_mapu();delay(1);}
		if (c=='P'&&(y_view<(n_map_ysize-25))) {y_view++;vypis_mapu();delay(1);}

		if (c==';') {}//help
		if (c=='<') {gotoxy(4,8);scanf("%s",name);save_map(name);vypis_mapu();}
		if (c=='=') {gotoxy(4,8);scanf("%s",name);load_map(name);vypis_mapu();}
		if (c=='Q'&&y_view<n_map_ysize-29) {y_view+=5;vypis_mapu();delay(1);}
      if (c=='Q') c=0;
		if (c=='I'&&y_view>4) {y_view-=5;vypis_mapu();delay(1);}

	   }
	}
else
	{
	klik=click(x,y);
	if (mys==1)
		{
		if (klik==0) {
			     switch (tool)
				   {
				   case 0: zapis_znak(x/8-3,y/8-10,znak-32);
					   break;
				   case 1:
					   if (prev==0)
					      {
					      xk=x;
					      yk=y;
					      prev=1;
					      delay(500);
					      }
					   else
					      {
					      prev=0;
					      bresenham(xk/8-3,yk/8-10,x/8-3,y/8-10,znak-32);
					      delay(500);
					      }
					   break;
				   case 2: //kruznice3(x/8-3,y/8-10,5,znak-32);
					   if (prev==0)
					      {
					      xk=x;
					      yk=y;
					      prev=1;
					      delay(500);
					      }
					   else
					      {
					      prev=0;
					      kruznice3(xk/8-3,yk/8-10,sqrt(abs(((x-xk)/8)*((x-xk)/8)+((y-yk)/8)*((y-yk)/8))),znak-32);
					      delay(500);
					      }
					   break;
				   case 3: if (prev==0)
					      {
					      xk=x;
					      yk=y;
					      prev=1;
					      delay(500);
					      }
					   else
					      {
					      prev=0;
					      elipsa1(xk/8-3,yk/8-10,abs((x-xk)/8),abs((y-yk)/8),znak-32);
					      delay(500);
					      }
					   break;
				   case 4: vypln(x/8-3,y/8-10,znak-32);
					   break;
				   case 5:
					   if (prev==0)
					      {
					      xk=x;
					      yk=y;
					      prev=1;
					      delay(500);
					      }
					   else
					      {
					      prev=0;
					      box(xk/8-3,yk/8-10,x/8-3,y/8-10,znak-32);
					      delay(500);
					      }
					   break;
				   }
			     }
		if (klik==1) {init_map();vypis_mapu();}
			     //{free(map);alok_pole();vypis_mapu();delay(100);}
		if (klik==2) {gotoxy(4,8);scanf("%s",name);load_map(name);vypis_mapu();}
		if (klik==3) {gotoxy(4,8);scanf("%s",name);save_map(name);vypis_mapu();}
		if (klik==4) {gotoxy(4,8);scanf("%s",name);import_raw(100,100,name);vypis_mapu();}
		//klik==5           je konec (podminka while)
		if (klik==6&&x_view>0)        {x_view--;vypis_mapu();delay(1);}
		if (klik==7&&x_view<n_map_xsize-35) {x_view++;vypis_mapu();delay(1);}
		if (klik==8&&y_view>0)        {y_view--;vypis_mapu();delay(1);}
		if (klik==9&&y_view<n_map_ysize-25) {y_view++;vypis_mapu();delay(1);}
		/*
		if (klik==10);
		if (klik==11);
		if (klik==12);			// reserved for RGB
		if (klik==13);
		if (klik==14);
		if (klik==15);
		*/
		if (klik>15&&klik<32) {str_i[znak-32].f=mapf[znak-32].f=klik-16;vypis_mapu();vypis_znaky();}
		if (klik>31&&klik<60) znak=klik;
		if (klik==60) {uiscan (&n_map_xsize,42,41);x_view=0;vypis_mapu();}
		if (klik==61) {uiscan (&n_map_ysize,42,44);y_view=0;vypis_mapu();}
		if (klik==62) {nazev();}
		if (klik==63) {}//help
		if (klik==64) {mode=2;}
		if (klik==65) {mode=3;}
		if (klik==66) {mode=4;}
		if (klik==67) {mode=5;}
		if (klik==68) {mode=(mode==6)?0:6;vypis_mapu();delay(300);}
		if (klik==69) {tool=0;}
		if (klik==70) {tool=1;}
		if (klik==71) {tool=2;}
		if (klik==72) {tool=3;}
		if (klik==73) {tool=4;}
		if (klik==74) {tool=5;}
      if (klik==75) {mode=(mode==0)?1:0;vypis_mapu();vypis_znaky();delay(500);}
      if (klik==76) {full=(full==0)?1:0;vypis_vse();}
		}
	else
		{
		if (klik==-1) {gotoxy(4,6);cprintf ("%d  - %d    >>> %d    ||| [%d;%d]-[%d;%d]    ",x/8+1,y/8+1,klik,x_view+1,y_view+1,x_view+35,y_view+25);}
		if (klik==0) {gotoxy(5,8);cprintf ("prosp = %d, znak = %d, barva = %d, pozadi = %d, vlastnost = %d               ",map.m[x/8-3+x_view][y/8-7+y_view],mapf[map.m[x/8-3+x_view][y/8-7+y_view]].c,mapf[map.m[x/8-3+x_view][y/8-7+y_view]].f,mapf[map.m[x/8-3+x_view][y/8-7+y_view]].b,mapf[map.m[x/8-3+x_view][y/8-7+y_view]].m);}
		if (klik>15&&klik<32) {str_i[znak-32].b=mapf[znak-32].b=klik-16;vypis_mapu();vypis_znaky();}
		if (klik>31&&klik<60) {if (mode==0){gotoxy(x/8+1,y/8+1);str_i[klik-32].c=mapf[klik-32].c=getch();vypis_mapu();vypis_znaky();}
				       else {gotoxy(4,6);scanf("%d",&str_i[klik-32].m),mapf[klik-32].m=str_i[klik-32].m;vypis_mapu();vypis_znaky();}}
		}
	}


textcolor(15);
textbackground(0);
gotoxy(5,3);
cprintf ("[%3d;%3d]",x_view+1,y_view+1);
gotoxy(5,4);
cprintf ("[%3d;%3d]",x_view+35,y_view+25);
gotoxy (5,6);
cprintf ("%d  - %d    >>> %d     %d       ",x/8+1,y/8+1,klik,tool);

}while (klik!=5&&c!=27&&c!='k'&&c!='q'&&c!='Q');

dis();
return 0;
}

void pis (char *p,char x,char y)
{
gotoxy(x,y);
cprintf (p);
}

void text()
{
int i,j;

textcolor(1);
pis("o",5,45);
textcolor(4);
pis("o",7,45);
textcolor(2);
pis("o",9,45);
textcolor(14);
pis("o",11,45);
textcolor(15);
pis("z",15,45);
textcolor(7);
pis ("?",2,2);
textcolor(4);
pis ("",39,36);
textcolor(3);
pis ("Mapovy editor pro hru PIZDOSKI",27,3);
pis ("InFRaReD && SEnklar && J@M",29,4);
pis ("<<<   R(000)   >>>",4,46);
pis ("<<<   G(000)   >>>",4,47);
pis ("<<<   B(000)   >>>",4,48);
textcolor(6);
//pis ("",40,8);
//pis ("",40,32);
pis ("x",40,41);
pis ("y",40,44);
pis ("",40,11);
pis ("",40,35);
pis ("",4,37);
pis ("",38,37);
pis ("NEW",70,11);
pis ("LOAD",70,14);
pis ("SAVE",70,17);
pis ("IMPORT",70,20);
pis ("QUIT",70,23);

pis ("Brush",50,11);
pis ("Line",50,14);
pis ("Circle",50,17);
pis ("Elipse",50,20);
pis ("Fill",50,23);
pis ("Box",50,26);
pis ("Mode",60,11);
pis ("Fullscr",60,14);

for (j=0;j<3;j++)
	for (i=0;i<32;i++)
	   {
	   textcolor(i/2);
	   pis ("",5+i,41+j);
	   }
gotoxy (42,41);
cprintf("%u",n_map_xsize);
gotoxy (42,44);
cprintf("%u",n_map_ysize);
gotoxy (5,39);
cprintf("%s",map.name);
vypis_znaky();
vypis_mapu();
}

void vypis_mapu()
{
int i,j;
int imax,jmax;

if (full==0) {imax=35;jmax=25;}
 else  {imax=75;jmax=38;}

  for (i=0;i<imax;i++)
	for (j=0;j<jmax;j++)

     switch (mode)
     {
      case 0:
	    {
	    gotoxy(4+i,11+j);
	    textcolor(mapf[map.m[i+x_view][j+y_view]].f);
	    textbackground(mapf[map.m[i+x_view][j+y_view]].b);
	    cprintf("%c",mapf[map.m[i+x_view][j+y_view]].c);
	    break;
	    }
       case 1:
	    {
	    gotoxy(4+i,11+j);
	    textcolor(mapf[map.m[i+x_view][j+y_view]].f);
	    textbackground(mapf[map.m[i+x_view][j+y_view]].b);
	    cprintf("%d",mapf[map.m[i+x_view][j+y_view]].m%10);
       break;
       }
      case 2:{}
      case 3:{}
      case 4:{}
      case 5:{}
      case 6:
       {
       //if something napis mapu plus pozice
	    gotoxy(4+i,11+j);
	    textcolor(mapf[map.m[i+x_view][j+y_view]].f);
	    textbackground(mapf[map.m[i+x_view][j+y_view]].b);
	    cprintf("%d",mapf[map.m[i+x_view][j+y_view]].m%10);
       break;
       }
     }
switch(mode)
{
      case 2:{
	     }
      case 3:{
	     }
      case 4:{
	     }
      case 5:{
	     }
      case 6:{
	 textbackground(0);
	 if (x_view<=start_x[0]&&x_view+35>start_x[0]&&y_view<=start_y[0]&&y_view+25>start_y[0])
	   {
	   textcolor(1);
	   pis("o",4+start_x[0]-x_view,11+start_y[0]-y_view);
	   }
	 if (x_view<=start_x[1]&&x_view+35>start_x[1]&&y_view<=start_y[1]&&y_view+25>start_y[1])
	   {
	   textcolor(4);
	   pis("o",4+start_x[1]-x_view,11+start_y[1]-y_view);
	   }
	 if (x_view<=start_x[2]&&x_view+35>start_x[2]&&y_view<=start_y[2]&&y_view+25>start_y[2])
	   {
	   textcolor(2);
	   pis("o",4+start_x[2]-x_view,11+start_y[2]-y_view);
	   }
	 if (x_view<=start_x[3]&&x_view+35>start_x[3]&&y_view<=start_y[3]&&y_view+25>start_y[3])
	   {
	   textcolor(14);
	   pis("o",4+start_x[3]-x_view,11+start_y[3]-y_view);
	   }
	break;
	     }

}
}



void zapis_znak(int x,int y, char prosp)
{
int imax,jmax;

if (full==0) {imax=35;jmax=25;}
 else  {imax=75;jmax=38;}

if (((x+x_view)>=0)&&(x<n_map_xsize)&&((y+y_view)>=0)&&(y<n_map_ysize))
{
if (prev!=0&&x>=0&&y>=0&&x<imax&&y<jmax)
   {
   if (prev==1)
      {
      *(screen+(x+3+(y+10)*80)*2+1)=(((mapf[map.m[x+x_view][y+y_view]].b*16+mapf[map.m[x+x_view][y+y_view]].f)^127)%128);    // 1:blik 3:back 4:fore
//      *(screen+(x+3+(y+10)*80)*2)='';    //ascii
      }
   else
      {
      *(screen+(x+3+(y+10)*80)*2+1)=((mapf[map.m[x+x_view][y+y_view]].b*16+mapf[map.m[x+x_view][y+y_view]].f)%128);    //fb
      }
   }
else {
gotoxy(x+4,y+11);
switch (mode){
case 0:{
       map.m[x+x_view][y+y_view] = prosp;
//       textcolor(str_i[prosp].f);
//       textbackground(str_i[prosp].b);
//       if (x>=0&&y>=0&&x<35&&y<25)cprintf("%c",str_i[prosp].c);
       textcolor(mapf[prosp].f);
       textbackground(mapf[prosp].b);
       if (x>=0&&y>=0&&x<imax&&y<jmax)cprintf("%c",mapf[prosp].c);
       break;
       }
case 1:{
       map.m[x+x_view][y+y_view] = prosp;
//       textcolor(str_i[prosp].f);
//       textbackground(str_i[prosp].b);
//       if (x>=0&&y>=0&&x<35&&y<25)cprintf("%d",str_i[prosp].m%10);
       textcolor(mapf[prosp].f);
       textbackground(mapf[prosp].b);
       if (x>=0&&y>=0&&x<imax&&y<jmax)cprintf("%d",mapf[prosp].m%10);
       break;
       }
case 2:{
       start_x[0]=x+x_view;
       start_y[0]=y+y_view;
       mode=6;
       vypis_mapu();
       break;
       }
case 3:{
       start_x[1]=x+x_view;
       start_y[1]=y+y_view;
       mode=6;
       vypis_mapu();
       break;
       }
case 4:{
       start_x[2]=x+x_view;
       start_y[2]=y+y_view;
       mode=6;
       vypis_mapu();
       break;
       }
case 5:{
       start_x[3]=x+x_view;
       start_y[3]=y+y_view;
       mode=6;
       vypis_mapu();
       break;
       }
case 6:{
       }
}
}
}
}

void vypis_znaky()
{
int i,j;

for (j=0;j<2;j++)
	for (i=0;i<14;i++)
	   {
	   textcolor(str_i[i+14*j].f);
	   textbackground(str_i[i+14*j].b);
	   gotoxy (44+j*2,11+2*i);
	   if (mode==0)
		cprintf ("%c",str_i[i+14*j].c);
	   else
		cprintf ("%d",str_i[i+14*j].m%10);
	   }
}

int click(int x,int y)
{
int i;
switch (full)
{
case 0:
MEZI (4,11,38,35)   return 0;        // mapa

MEZI (69,10,78,12)  return 1;        // new
MEZI (69,13,78,15) return 2;        // load
MEZI (69,16,78,18) return 3;        // save
MEZI (69,19,78,21) return 4;        // import
MEZI (69,22,78,24) return 5;        // quit

BOD (4,37)         return 6;        // doleva
BOD (38,37)        return 7;        // doprava
BOD (40,11)         return 8;        // nahoru
BOD (40,35)        return 9;        // dolu

MEZI (4,46,8,46)   return 10;       // R vlevo
MEZI (17,46,21,46) return 11;       // R vpravo
MEZI (4,47,8,47)   return 12;       // G vlevo
MEZI (17,47,21,47) return 13;       // G vpravo
MEZI (4,48,8,48)   return 14;       // B vlevo
MEZI (17,48,21,48) return 15;       // B vpravo

for (i=0;i<16;i++)
	MEZI (5+2*i,40,6+2*i,44) return (i+16);  // barvy

for (i=0;i<14;i++)
	BOD  (44,11+2*i) return (i+32);  // 1.sloupec znaky
for (i=0;i<14;i++)
	BOD (46,11+2*i) return (i+46);  // 2.sloupec znaky

MEZI (39,40,47,42) return 60;
MEZI (39,43,47,45) return 61;

MEZI (5,39,36,39) return 62;       // name of the map
BOD (2,2) return 63;               // help
BOD (5,45) return 64;              //player 1
BOD (7,45) return 65;              //player 2
BOD (9,45) return 66;              //player 3
BOD (11,45) return 67;             //player 4
BOD (15,45) return 68;             //view starts

MEZI (49,10,58,12) return 69;      //brush
MEZI (49,13,58,15) return 70;      //line
MEZI (49,16,58,18) return 71;      //circle
MEZI (49,19,58,21) return 72;      //elipse
MEZI (49,22,58,24) return 73;      //vypln
MEZI (49,25,58,27) return 74;      //box
MEZI (59,10,68,12) return 75;      //mode
MEZI (59,13,68,15) return 76;      //full
break;
case 1:
MEZI (3,8,79,48) return 0;  //mapa
break;
}
return -1;
}

void tabulka()
{
rangey(8,376);
rangex(8,624);
textcolor(1);
ramce2 (1,1,80,49);
textcolor(4);
ramce1 (3,2,78,5);

ramce1 (3,10,41,38);  // mapa

ramce1 (43,10,47,38); // paleta

ramce1 (69,10,78,12);
ramce1 (69,13,78,15);
ramce1 (69,16,78,18);
ramce1 (69,19,78,21);
ramce1 (69,22,78,24);
ramce1 (4,40,37,44);
ramce1 (39,40,47,42);
ramce1 (39,43,47,45);

ramce1 (59,10,68,12);
ramce1 (59,13,68,15);
ramce1 (59,16,68,18);
ramce1 (59,19,68,21);
ramce1 (59,22,68,24);

ramce1 (49,10,58,12);
ramce1 (49,13,58,15);
ramce1 (49,16,58,18);
ramce1 (49,19,58,21);
ramce1 (49,22,58,24);
ramce1 (49,25,58,27);

vert1 (40,42,41);
vert1 (43,45,41);

horiz1 (3,41,36);
vert1 (10,38,39);
horiz1 (39,41,34);
horiz1 (39,41,12);

vert1 (36,38,5);
vert1 (36,38,37);

}

void ramce2(char x1,char y1,char x2,char y2)
{
char i;
gotoxy(x1,y1);
cprintf("");
gotoxy(x2,y1);
cprintf("");
gotoxy(x1,y2);
cprintf("");
gotoxy(x2,y2);
cprintf("");
for (i=x1+1;i<x2;i++)
	{
	 gotoxy (i,y1);
	 cprintf("");
	 gotoxy (i,y2);
	 cprintf("");
	}
for (i=y1+1;i<y2;i++)
	{
	 gotoxy (x1,i);
	 cprintf("");
	 gotoxy (x2,i);
	 cprintf("");
	}
}

void ramce1(char x1,char y1,char x2,char y2)
{
char i;
gotoxy(x1,y1);
cprintf("");
gotoxy(x2,y1);
cprintf("");
gotoxy(x1,y2);
cprintf("");
gotoxy(x2,y2);
cprintf("");
for (i=x1+1;i<x2;i++)
	{
	 gotoxy (i,y1);
	 cprintf("");
	 gotoxy (i,y2);
	 cprintf("");
	}
for (i=y1+1;i<y2;i++)
	{
	 gotoxy (x1,i);
	 cprintf("");
	 gotoxy (x2,i);
	 cprintf("");
	}
}

void horiz1 (char x1,char x2,char y)
{
int i;
gotoxy(x1,y);
cprintf("");
gotoxy(x2,y);
cprintf("");

for (i=x1+1;i<x2;i++)
	{
	 gotoxy (i,y);
	 cprintf("");
	}
}

void vert1 (char y1,char y2,char x)
{
int i;
gotoxy(x,y1);
cprintf("");
gotoxy(x,y2);
cprintf("");

for (i=y1+1;i<y2;i++)
	{
	 gotoxy (x,i);
	 cprintf("");
	}
}

void uiscan (unsigned int *x,int x_scr, int y_scr)
{
char plus;
char cntr;
textcolor(15);
textbackground(0);
znovu:
cntr=0;
gotoxy(x_scr,y_scr);
cprintf ("     ");
gotoxy(x_scr,y_scr);
*x=0;
do{
plus = getche();
if (plus>='0'&&plus<='9')
	{
	*x=*x*10+(plus-48);
	cntr++;
	}
gotoxy(x_scr+cntr,y_scr);
}while (plus!=13&&cntr!=3);
if (*x<10||*x>256) goto znovu;
}


void load_map(char map_file[])
{
  int i,i1,i2,ix,iy;
  unsigned char chx;
  FILE *in;

  textcolor(15);
  textbackground(0);

//  strcpy (map_file,PRIPONA);

  gotoxy (4,11);
  cprintf("Map file name: %s", map_file);

  if ((in = fopen(map_file, "rb")) == NULL)
  {
	 gotoxy (4, 12);
	 cprintf("Cannot open %s for reading.", map_file);
  }
  else
  {
	// Header
	gotoxy (4, 12);
	cprintf("Map ID: ");
	for (i1=0; i1<5; i1++)
	{
	  chx=fgetc(in);
	  printf("%c", chx);
	}

	// Map name
	strcpy(map.name, "");
	for (i1=0; i1<32; i1++)
	{
	  chx=fgetc(in);
	  map.name[i1]=chx;
	}
	map.name[32]=0;
	gotoxy (4,13);
	cprintf("Map name: ");
	gotoxy (4,14);
	cprintf("%s", map.name);
	gotoxy (5,39);
	cprintf("%s",map.name);
	// Mapf size
	n_mapf_size=fgetc(in); // MAPF_SIZE

	gotoxy (4,15);
	cprintf("mapf_size: %i", n_mapf_size);

	// Map size
	n_map_xsize=fgetc(in); // X_SIZE
	n_map_ysize=fgetc(in); // Y_SIZE

	gotoxy(42,41);
	printf("%3i",n_map_xsize);
	gotoxy(42,44);
	printf("%3i",n_map_ysize);

	gotoxy (4,16);
	cprintf("x_size / max_x_size: %i / %i", n_map_xsize, MAX_MAP_XSIZE);
	gotoxy (4,17);
	cprintf("y_size / max_y_size: %i / %i", n_map_ysize, MAX_MAP_YSIZE);

	// Players
	i2=fgetc(in); // Number of players
	for (i1=0; i1<i2; i1++)
	{
	  //pl[i1].x[0]=fgetc(in);
	  //pl[i1].y[0]=fgetc(in);
	  start_x[i1]=fgetc(in);
	  start_y[i1]=fgetc(in);
	}
	gotoxy (4,18);
	printf("Players: %i\n\r", i2);

	for (i1=0; i1<n_mapf_size; i1++)
	{
	  mapf[i1].m=fgetc(in);
	  mapf[i1].c=fgetc(in);
	  mapf[i1].f=fgetc(in);
	  mapf[i1].b=fgetc(in);
	}

	if ( (n_map_xsize<=MAX_MAP_XSIZE) && (n_map_ysize<=MAX_MAP_YSIZE) )
	{

	  for (iy=0; iy<n_map_ysize; iy++)
	  for (ix=0; ix<n_map_xsize; ix++)
	  {
		map.m[ix][iy]=fgetc(in);
	  }


	  gotoxy (4,19);
	  cprintf("OK, map successfully loaded.\n\r");
	}
	else
	{
	  gotoxy (4,19);
	  cprintf("Map size is out of range.\n\r");
	}

	fclose(in);
  }

  for (i=0;i<28;i++)
    str_i[i]=mapf[i];

  vypis_znaky();
  gotoxy (4,20);
  cprintf("Press any key...");
  getch();
}

void save_map(char map_file[])
{
  int i1,i2;
  FILE *out;

  textcolor(15);
  textbackground(0);

//  strcpy (map_file,PRIPONA);
  if ((out = fopen(map_file, "wb")) == NULL)
  {
	 gotoxy (4,11);
	 cprintf("Cannot open output file.");
  }
  else
  {
	fprintf(out, "PMF10");

	// Map name
	//               12345678901234567890123456789012
	//strcpy(map.name,"-=          Test map          =-");
	fprintf(out,map.name);

	// Mapf size
	fputc(n_mapf_size, out);

	// Map size
	fputc(n_map_xsize, out);
	fputc(n_map_ysize, out);

	// Players
	fputc(4, out);

	fputc(start_x[0], out); fputc(start_y[0], out); // Player1
	fputc(start_x[1], out); fputc(start_y[1], out); // Player2
	fputc(start_x[2], out); fputc(start_y[2], out); // Player3
	fputc(start_x[3], out); fputc(start_y[3], out); // Player4
/*     old
//          x                             y
	fputc(5, out);                fputc(5, out);               // Player1
	fputc((n_map_xsize-13), out); fputc((n_map_ysize-7), out); // Player2
	fputc((n_map_xsize-7), out);  fputc(5, out);               // Player3
	fputc(10, out);               fputc((n_map_ysize-7), out); // Player4
*/
	for (i1=0; i1<n_mapf_size; i1++)
	{
	  fputc(mapf[i1].m, out);
	  fputc(mapf[i1].c, out);
	  fputc(mapf[i1].f, out);
	  fputc(mapf[i1].b, out);
	}

	for (i2=0; i2<n_map_ysize; i2++)
	{
	  for (i1=0; i1<n_map_xsize; i1++)
	  {
		fputc(map.m[i1][i2], out);
	  }
	}
	fclose(out);

	gotoxy (4,12);
	cprintf("OK, map generated successfully.\n\r");
  }

  gotoxy (4,13);
  cprintf("Press any key...");
  getch();
}
/*
void save_map(char map_file[])
{
  int i1,i2;
  FILE *out;

  textcolor(15);
  textbackground(0);

//  strcpy (map_file,PRIPONA);
  if ((out = fopen(map_file, "wb")) == NULL)
  {
	 gotoxy (4,11);
	 cprintf("Cannot open output file.");
  }
  else
  {
	fprintf(out, "PMF10");

	// Map name
	//               12345678901234567890123456789012
	//strcpy(map.name,"-=          Test map          =-");
	fprintf(out,nameofmap);

	// Mapf size
	fputc(n_mapf_size, out);

	// Map size
	fputc(n_map_xsize, out);
	fputc(n_map_ysize, out);

	// Players
	fputc(4, out);
//          x                             y
	fputc(start_x[0], out); fputc(start_y[0], out); // Player1
	fputc(start_x[1], out); fputc(start_y[1], out); // Player2
	fputc(start_x[2], out); fputc(start_y[2], out); // Player3
	fputc(start_x[3], out); fputc(start_y[3], out); // Player4

	for (i1=0; i1<n_mapf_size; i1++)
	{
	  fputc(mapf[i1].m, out);
	  fputc(mapf[i1].c, out);
	  fputc(mapf[i1].f, out);
	  fputc(mapf[i1].b, out);
	}

	for (i2=0; i2<n_map_ysize; i2++)
	{
	  for (i1=0; i1<n_map_xsize; i1++)
	  {
		fputc(map.m[i1][i2], out);
	  }
	}
	fclose(out);

	gotoxy (4,12);
	cprintf("OK, map generated successfully.\n\r");
  }

  gotoxy (4,13);
  cprintf("Press any key...");
  getch();
}
*/

void import_raw(int x1, int y1, char fname[])
{
  int i1,ix,iy;
  FILE *in;

  if ((in = fopen(fname, "rb")) == NULL)
  {
	 gotoxy (4,11);
	 printf("Cannot open %s for reading.", fname);
  }
  else
  {
	for (iy=0; iy<y1; iy++)
	for (ix=0; ix<x1; ix++)
	{
	  i1=fgetc(in);
	  if ( (ix<n_map_xsize) && (iy<n_map_ysize) )
	  {
		map.m[ix][iy]=i1;
	  }
	}
	fclose(in);
  }
  gotoxy (4,12);
  cprintf("Press any key...");
  getch();
}

void init_map()
// Initialise testing map
{
  int ix,iy;

  // Map name
//  strcpy(map.name,"Map1");

  // Initialise map fields
  for (iy=0; iy<n_map_ysize; iy++)
  for (ix=0; ix<n_map_xsize; ix++)
  {
	map.m[ix][iy]=0; // Clear all map fields

	// Create map borders
	if ( (ix==0) || (iy==0) || (ix==(n_map_xsize-1)) || (iy==(n_map_ysize-1)) )
	  {  map.m[ix][iy]=1;  }
  }
}

void init_mapf()
{
int i;
/*
  // m=0 ... normal playing field
  // m=1 ... wall
  // m=2 ... tuneler playing filed
  // m=3 ... eat
  // m=4 ... CTF - flag - begin
  // m=5 ... CTF - flag - end

  int i1;

  mapf[0].m= 0; mapf[0].f= 1; mapf[0].b= 1; mapf[0].c=' ';
  mapf[1].m= 1; mapf[1].f=14; mapf[1].b=14; mapf[1].c='';
  mapf[2].m= 2; mapf[2].f= 9; mapf[2].b= 1; mapf[2].c='';
  mapf[3].m= 3; mapf[3].f=10; mapf[3].b= 1; mapf[3].c='O';
  mapf[4].m= 1; mapf[4].f= 8; mapf[4].b= 0; mapf[4].c='@';

  // CTF
  mapf[5].m= 4; mapf[5].f=10; mapf[5].b= 7; mapf[5].c='';
  mapf[6].m= 5; mapf[6].f= 9; mapf[6].b= 7; mapf[6].c='';

  // Other objects
  mapf[7].m= 0; mapf[7].f= 7; mapf[7].b= 0; mapf[7].c='x';
  mapf[8].m= 0; mapf[8].f= 7; mapf[8].b= 0; mapf[8].c='x';
  mapf[9].m= 0; mapf[9].f= 7; mapf[9].b= 0; mapf[9].c='x';


  // Teleport
  for (i1=0; i1<10; i1++)
  {
	mapf[(i1+10)].m=i1+10; mapf[(i1+10)].f= 7; mapf[(i1+10)].b= 1; mapf[(i1+10)].c=48+i1;
	mapf[(i1+20)].m=i1+20; mapf[(i1+20)].f= 7; mapf[(i1+20)].b= 1; mapf[(i1+20)].c=48+i1;
  }
*/
for (i=0;i<28;i++)
  mapf[i]=str_i[i];

  n_mapf_size=28;
}

void init_znaky()
{
char i;
char znaky[28]= {' ','','','O',
		 '@','','','x',
		 'x','x','*','*',
		 '*','*','*','*',
		 '*','*','*','*',
		 '*','*','*','*',
		 '*','*','*','*',};
char barvy[28]= {1,14,9,10,
		 8,10,9,7,
		 7,7,2,3,
		 4,5,6,7,
		 8,9,10,2,
		 3,4,5,6,
		 7,8,9,10,};
char pozadi[28]= {1,14,1,1,
		 0,7,7,0,
		 0,0,1,1,
		 1,1,1,1,
		 1,1,1,1,
		 1,1,1,1,
		 1,1,1,1,};
char prosp[28]= {0,1,2,3,
		 1,4,5,0,
		 0,0,10,11,
		 12,13,14,15,
		 16,17,18,20,
		 21,22,23,24,
		 25,26,27,28,};
for (i=0;i<28;i++)
  {
  str_i[i].c=znaky[i];
  str_i[i].f=barvy[i];
  str_i[i].b=pozadi[i];
  str_i[i].m=prosp[i];
  }
}

void nazev()
{
int i;
char c;
textbackground(0);
textcolor(15);
for (i=0;i<32;i++)
  {
  gotoxy (5+i,39);
  c=getche();
  map.name[i]=c;
  }
}

void bresenham (int x1,int y1,int x2,int y2,char znak)
{
int dx,dy,d,d10,d11,i;
int pom;

if (x1>x2) {pom=x2;x2=x1;x1=pom;}
if (y1>y2) {pom=y2;y2=y1;y1=pom;}

dx=x2-x1;
dy=y2-y1;
d=2*dy-dx;
d10=2*dy;
d11=2*dy-2*dx;
for (i=0;i<=dx;i++)
 {
 zapis_znak(x1,y1,znak);
 if (d>0) {x1++;y1++;d+=d11;}
 else {x1++;d+=d10;}
 }
}

void kruznice3 (int xs,int ys,int r,char znak)
{
int x=0,y=r;
int d=1-r,d1=3,d2=-2*r+5;
int i;

symetrie1 (x,y,xs,ys,znak);

while (x<y)
   {
   if (d<0)
      {
      d+=d1;
      d1+=2;
      d2+=2;
      x++;
      }
   else
      {
      d+=d2;
      d1+=2;
      d2+=4;
      x++;
      y--;
      }
   symetrie1 (x,y,xs,ys,znak);
   }
}
void vypln(int x,int y,char znak)
{
unsigned char pom;
char zmena=0;
int i,j;

pom=map.m[x+x_view][y+y_view];


if (pom!=znak)
{
map.m[x+x_view][y+y_view]=255;
do{
zmena=0;
for (i=0;i<=n_map_xsize;i++)
for (j=0;j<=n_map_ysize;j++)
    if (map.m[i][j]==255)
    {
    if (i<n_map_xsize)
      if (map.m[i+1][j]==pom)
          {map.m[i+1][j]=255;zmena=1;}
    if (i>0)
      if (map.m[i-1][j]==pom)
          {map.m[i-1][j]=255;zmena=1;}
    if (j<n_map_ysize)
      if (map.m[i][j+1]==pom)
          {map.m[i][j+1]=255;zmena=1;}
    if (j>0)
      if (map.m[i][j-1]==pom)
          {map.m[i][j-1]=255;zmena=1;}
    }
}while(zmena==1);

for (i=0;i<=n_map_xsize;i++)
for (j=0;j<=n_map_ysize;j++)
    if (map.m[i][j]==255) map.m[i][j]=znak;
}
vypis_mapu();
}

void elipsa1 (int xs,int ys,int as,int bs, char znak)
{
float a=as*as,b=bs*bs;
float d=b-a*bs+a/4;
int x=0,y=bs;

symetrie2 (x,y,xs,ys,znak);
while (a*(y-0.5)>b*(x+1))
     {
     if (d<0)
       {
       d+=b*(2*x+3);
       x++;
       }
     else
       {
       d+=b*(2*x+3)+a*(-2*y+2);
       x++;
       y--;
       }
     symetrie2 (x,y,xs,ys,znak);
     }
d=b*(x+0.5)*(x+0.5)+a*(y-1)*(y-1)-a*b;
while (y>0)
     {
     if (d<0)
       {
       d+=b*(2*x+2)+a*(-2*y+3);
       x++;
       y--;
       }
     else
       {
       d+=a*(-2*y+3);
       y--;
     symetrie2 (x,y,xs,ys,znak);
     }
}
}

void box (int x1,int y1,int x2,int y2,char znak)
{
int i;
int pom;

if (x1>x2) {pom=x2;x2=x1;x1=pom;}
if (y1>y2) {pom=y2;y2=y1;y1=pom;}

for (i=x1;i<=x2;i++)
    {
    zapis_znak(i,y1,znak);
    zapis_znak(i,y2,znak);
    }
for (i=y1;i<=y2;i++)
    {
    zapis_znak(x1,i,znak);
    zapis_znak(x2,i,znak);
    }
}

void symetrie1 (int x,int y,int xs,int ys,char znak)
{
  zapis_znak(x+xs,y+ys,znak);
  zapis_znak(-x+xs,y+ys,znak);
  zapis_znak(x+xs,-y+ys,znak);
  zapis_znak(-x+xs,-y+ys,znak);
  zapis_znak(y+xs,x+ys,znak);
  zapis_znak(-y+xs,x+ys,znak);
  zapis_znak(y+xs,-x+ys,znak);
  zapis_znak(-y+xs,-x+ys,znak);
}

void symetrie2 (int x,int y,int xs,int ys,char znak)
{
  zapis_znak(x+xs,y+ys,znak);
  zapis_znak(-x+xs,y+ys,znak);
  zapis_znak(x+xs,-y+ys,znak);
  zapis_znak(-x+xs,-y+ys,znak);
}


void vypis_vse()
{
switch (full)
{
case 0: {
        clrscr();
        locate (1,1);
        tabulka();
        text();
        break;
        }
case 1: {
        clrscr();
        textcolor(4);
        ramce1 (3,2,78,5);
        ramce2(3,10,79,49);
        textcolor(7);
        pis ("?",2,2);
        textcolor(3);
        pis ("Mapovy editor pro hru PIZDOSKI",27,3);
        pis ("InFRaReD && SEnklar && J@M",29,4);
        if (x_view-n_map_xsize<75)
        x_view=n_map_xsize-75;
        if (y_view-n_map_ysize<38)
        y_view=n_map_ysize-38;
        vypis_mapu();
        break;
        }
}
}

